<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: svm_one_class_trainer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">svm_one_class_trainer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2010  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_SVm_ONE_CLASS_TRAINER_Hh_ </span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_SVm_ONE_CLASS_TRAINER_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;svm_one_class_trainer_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;limits&gt;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;function.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;kernel.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;../optimization/optimization_solve_qp3_using_smo.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a> </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">typename</span> K </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        &gt;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classdlib_1_1svm__one__class__trainer.html">   25</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer</a></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">typedef</span> K kernel_type;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type scalar_type;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">typedef</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> <a class="code" href="structdlib_1_1decision__function.html">trained_function_type</a>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer</a> (</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        ) :</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            nu(0.1),</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            cache_size(200),</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            eps(0.001)</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        }</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer</a> (</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_, </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="keyword">const</span> scalar_type&amp; nu_</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        ) :</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            kernel_function(kernel_),</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            nu(nu_),</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            cache_size(200),</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            eps(0.001)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            DLIB_ASSERT(0 &lt; nu &amp;&amp; nu &lt;= 1,</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                <span class="stringliteral">&quot;\tsvm_one_class_trainer::svm_one_class_trainer(kernel,nu)&quot;</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t nu: &quot;</span> &lt;&lt; nu </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;                );</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        }</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordtype">void</span> set_cache_size (</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            <span class="keywordtype">long</span> cache_size_</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        )</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            DLIB_ASSERT(cache_size_ &gt; 0,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                <span class="stringliteral">&quot;\tvoid svm_one_class_trainer::set_cache_size(cache_size_)&quot;</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t cache_size: &quot;</span> &lt;&lt; cache_size_ </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                );</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            cache_size = cache_size_;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordtype">long</span> get_cache_size (</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordflow">return</span> cache_size;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordtype">void</span> set_epsilon (</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            scalar_type eps_</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        )</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        {</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            DLIB_ASSERT(eps_ &gt; 0,</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                <span class="stringliteral">&quot;\tvoid svm_one_class_trainer::set_epsilon(eps_)&quot;</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t eps: &quot;</span> &lt;&lt; eps_ </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                );</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            eps = eps_;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        }</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">const</span> scalar_type get_epsilon (</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword">        </span>{ </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keywordflow">return</span> eps;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordtype">void</span> set_kernel (</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="keyword">const</span> kernel_type&amp; k</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        )</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        {</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            kernel_function = k;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        }</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">const</span> kernel_type&amp; get_kernel (</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="keywordflow">return</span> kernel_function;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        }</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordtype">void</span> set_nu (</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            scalar_type nu_</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        )</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            DLIB_ASSERT(0 &lt; nu_ &amp;&amp; nu_ &lt;= 1,</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                <span class="stringliteral">&quot;\tvoid svm_one_class_trainer::set_nu(nu_)&quot;</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t nu: &quot;</span> &lt;&lt; nu_ </div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;                );</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            nu = nu_;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> scalar_type get_nu (</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordflow">return</span> nu;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        }</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            &gt;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> train (</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <span class="keywordflow">return</span> do_train(mat(x));</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        }</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer</a>&amp; item</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        )</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(kernel_function, item.kernel_function);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(nu,              item.nu);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(cache_size,      item.cache_size);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(eps,             item.eps);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        }</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            &gt;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> do_train (</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> K::scalar_type scalar_type;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classdlib_1_1matrix.html">decision_function&lt;K&gt;::sample_vector_type</a> sample_vector_type;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classdlib_1_1matrix.html">decision_function&lt;K&gt;::scalar_vector_type</a> scalar_vector_type;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            DLIB_ASSERT(is_col_vector(x) &amp;&amp; x.size() &gt; 0,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                <span class="stringliteral">&quot;\tdecision_function svm_one_class_trainer::train(x)&quot;</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t x.nr(): &quot;</span> &lt;&lt; x.nr() </div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t x.nc(): &quot;</span> &lt;&lt; x.nc() </div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                );</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            scalar_vector_type alpha;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            <a class="code" href="classdlib_1_1solve__qp3__using__smo.html">solve_qp3_using_smo&lt;scalar_vector_type&gt;</a> solver;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160; </div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            solver(symmetric_matrix_cache&lt;float&gt;(kernel_matrix(kernel_function,x), cache_size), </div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                   zeros_matrix&lt;scalar_type&gt;(x.size(),1),</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                   ones_matrix&lt;scalar_type&gt;(x.size(),1), </div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                   nu*x.size(),</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                   1,</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                   1,</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                   alpha,</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                   eps);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            scalar_type rho;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            calculate_rho(alpha,solver.get_gradient(),rho);</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160; </div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            <span class="comment">// count the number of support vectors</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> sv_count = (long)sum(alpha != 0);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160; </div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            scalar_vector_type sv_alpha;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            sample_vector_type support_vectors;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160; </div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            <span class="comment">// size these column vectors so that they have an entry for each support vector</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            sv_alpha.set_size(sv_count);</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            support_vectors.set_size(sv_count);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="comment">// load the support vectors and their alpha values into these new column matrices</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            <span class="keywordtype">long</span> idx = 0;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; alpha.nr(); ++i)</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            {</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                <span class="keywordflow">if</span> (alpha(i) != 0)</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                {</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                    sv_alpha(idx) = alpha(i);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                    support_vectors(idx) = x(i);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;                    ++idx;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;                }</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            }</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="comment">// now return the decision function</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;K&gt;</a> (sv_alpha, rho, kernel_function, support_vectors);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        }</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160; </div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            <span class="keyword">typename</span> scalar_vector_type</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            &gt;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordtype">void</span> calculate_rho(</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;            <span class="keyword">const</span> scalar_vector_type&amp; alpha,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            <span class="keyword">const</span> scalar_vector_type&amp; df,</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            scalar_type&amp; rho</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            <span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            <span class="keywordtype">long</span> num_p_free = 0;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            scalar_type sum_p_free = 0;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160; </div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160; </div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;            scalar_type upper_bound_p;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;            scalar_type lower_bound_p;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160; </div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;            find_min_and_max(df, upper_bound_p, lower_bound_p);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160; </div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            <span class="keywordflow">for</span>(<span class="keywordtype">long</span> i = 0; i &lt; alpha.nr(); ++i)</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            {</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;                <span class="keywordflow">if</span>(alpha(i) == 1)</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;                {</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                    <span class="keywordflow">if</span> (df(i) &gt; upper_bound_p)</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                        upper_bound_p = df(i);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;                }</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                <span class="keywordflow">else</span> <span class="keywordflow">if</span>(alpha(i) == 0)</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                {</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                    <span class="keywordflow">if</span> (df(i) &lt; lower_bound_p)</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                        lower_bound_p = df(i);</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;                }</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                {</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                    ++num_p_free;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                    sum_p_free += df(i);</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            }</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160; </div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            scalar_type r1;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            <span class="keywordflow">if</span>(num_p_free &gt; 0)</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                r1 = sum_p_free/num_p_free;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                r1 = (upper_bound_p+lower_bound_p)/2;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160; </div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;            rho = r1;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        } </div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        kernel_type kernel_function;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        scalar_type nu;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">long</span> cache_size;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        scalar_type eps;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    }; <span class="comment">// end of class svm_one_class_trainer</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160; </div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> K&gt;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer&lt;K&gt;</a>&amp; a,</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <a class="code" href="classdlib_1_1svm__one__class__trainer.html">svm_one_class_trainer&lt;K&gt;</a>&amp; b</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160; </div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160; </div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;}</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="preprocessor">#endif // DLIB_SVm_ONE_CLASS_TRAINER_Hh_</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1svm__one__class__trainer_html"><div class="ttname"><a href="classdlib_1_1svm__one__class__trainer.html">dlib::svm_one_class_trainer</a></div><div class="ttdef"><b>Definition:</b> svm_one_class_trainer.h:25</div></div>
<div class="ttc" id="anamespacedlib_html_ad37c77243cb5521ab47cefddf651cda5"><div class="ttname"><a href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">dlib::exchange</a></div><div class="ttdeci">void exchange(T &amp;a, T &amp;b)</div><div class="ttdef"><b>Definition:</b> algs.h:326</div></div>
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix&lt; sample_type, 0, 1, mem_manager_type &gt;</a></div></div>
<div class="ttc" id="astructdlib_1_1decision__function_html"><div class="ttname"><a href="structdlib_1_1decision__function.html">dlib::decision_function</a></div><div class="ttdef"><b>Definition:</b> function.h:27</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<div class="ttc" id="aclassdlib_1_1solve__qp3__using__smo_html"><div class="ttname"><a href="classdlib_1_1solve__qp3__using__smo.html">dlib::solve_qp3_using_smo</a></div><div class="ttdef"><b>Definition:</b> optimization_solve_qp3_using_smo.h:45</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
